"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkRequiredFiles = checkRequiredFiles;
var _fs = _interopRequireDefault(require("fs"));
var _path = _interopRequireDefault(require("path"));
require("react-dev-utils/checkRequiredFiles");
var _path2 = require("../utils/path");
/**
 * Fix `--app-src ./website`
 * [create-react-app/react-dev-utils/checkRequiredFiles.js](https://github.com/facebook/create-react-app/blob/0f6fc2bc71d78f0dcae67f3f08ce98a42fc0a57c/packages/react-dev-utils/checkRequiredFiles.js#L14-L30)
 */
function checkRequiredFiles(paths, isNotCheckHTML) {
  var checkRequiredFilesPath = "".concat(_path2.reactDevUtils, "/checkRequiredFiles");
  require.cache[require.resolve(checkRequiredFilesPath)].exports = function () {
    var files = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    files = files.map(function (item) {
      if (/(\.html)$/.test(item) && isNotCheckHTML) {
        return;
      }
      if (paths._oldPaths && item === paths._oldPaths.appIndexJs) {
        return paths.appIndexJs;
      }
      return item;
    }).filter(Boolean);
    var currentFilePath;
    try {
      files.forEach(function (filePath) {
        currentFilePath = filePath;
        filePath && _fs["default"].accessSync(filePath, _fs["default"].constants.F_OK);
      });
      return true;
    } catch (err) {
      if (currentFilePath) {
        var dirName = _path["default"].dirname(currentFilePath);
        var fileName = _path["default"].basename(currentFilePath);
        console.log('\x1b[1;31m Could not find a required file. \x1b[0m');
        console.log("\x1B[1;31m   Name:  \x1B[0m ".concat(fileName));
        console.log("\x1B[1;31m   Searched in: \x1B[0m \x1B[1;36m".concat(dirName, "\x1B[0m"));
      }
      return false;
    }
  };
}