"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.overridesChoosePort = overridesChoosePort;
var _regeneratorRuntime2 = _interopRequireDefault(require("@babel/runtime/helpers/regeneratorRuntime"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _path = require("../utils/path");
var _cacheData = require("../utils/cacheData");
/**
 * Try to get the client `port:3000` after startup
 * - `<APP Root>/node_modules/react-dev-utils/WebpackDevServerUtils.js`
 * - [create-react-app/react-dev-utils/WebpackDevServerUtils.js](https://github.com/facebook/create-react-app/blob/0f6fc2bc71d78f0dcae67f3f08ce98a42fc0a57c/packages/react-dev-utils/WebpackDevServerUtils.js#L448-L493)
 */
function overridesChoosePort(port) {
  var WebpackDevServerUtilsPath = "".concat(_path.reactDevUtils, "/WebpackDevServerUtils");
  var devServerUtils = require(WebpackDevServerUtilsPath);
  var choosePort = devServerUtils.choosePort;
  devServerUtils.choosePort = function (host, defaultPort) {
    return new Promise( /*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/(0, _regeneratorRuntime2["default"])().mark(function _callee(resolve) {
        var currentPort;
        return (0, _regeneratorRuntime2["default"])().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (port) {
                resolve(port);
              }
              _context.next = 3;
              return choosePort(host, defaultPort);
            case 3:
              currentPort = _context.sent;
              (0, _cacheData.cacheData)({
                port: currentPort,
                defaultPort: defaultPort
              });
              resolve(currentPort);
            case 6:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  };
  require.cache[require.resolve(WebpackDevServerUtilsPath)].exports = devServerUtils;
}