"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.overridesClearConsole = overridesClearConsole;
var _path = require("../utils/path");
function clearConsole() {}
/**
 * Do not clear the command line information.
 * - `node_modules/react-dev-utils/clearConsole.js`
 * - [create-react-app/react-dev-utils/clearConsole.js](https://github.com/facebook/create-react-app/blob/0f6fc2bc71d78f0dcae67f3f08ce98a42fc0a57c/packages/react-dev-utils/clearConsole.js#L10-L14)
 */
function overridesClearConsole(options) {
  if (options && options['clear-console'] === false || process.env.KKT_CLEAR_CONSOLE === 'true') {
    var clearConsolePath = "".concat(_path.reactDevUtils, "/clearConsole");
    require(clearConsolePath);
    require.cache[require.resolve(clearConsolePath)].exports = clearConsole;
  }
}