import { ParsedArgs } from 'minimist';
import { Paths } from '../utils/path';
export type OverridePaths = Paths & {
    _oldPaths: OverridePaths;
};
/**
 * Override Paths
 * @param {ParsedArgs | undefined} argvs `argvs['app-src']`
 * @param {Record<string, string>} opts
 * - [create-react-app/react-scripts/react-scripts/config/paths.js](https://github.com/facebook/create-react-app/blob/0f6fc2bc71d78f0dcae67f3f08ce98a42fc0a57c/packages/react-scripts/config/paths.js#L83-L105)
 */
export declare const overridePaths: (argvs?: ParsedArgs, opts?: Record<string, string>) => OverridePaths;
