"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.overridesPrintInstructions = overridesPrintInstructions;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _path = require("../utils/path");
var _staticDoc = require("../plugins/staticDoc");
/**
 * Try to get the client `port:3000` after startup
 * - `<APP Root>/node_modules/react-dev-utils/WebpackDevServerUtils.js`
 * - [create-react-app/react-dev-utils/WebpackDevServerUtils.js](https://github.com/facebook/create-react-app/blob/d960b9e38c062584ff6cfb1a70e1512509a966e7/packages/react-dev-utils/WebpackDevServerUtils.js#L78-L101)
 */
function overridesPrintInstructions(opt) {
  var WebpackDevServerUtilsPath = "".concat(_path.reactDevUtils, "/WebpackDevServerUtils");
  var devServerUtils = require(WebpackDevServerUtilsPath);
  var createCompiler = devServerUtils.createCompiler;
  devServerUtils.createCompiler = function (option) {
    if (opt.docs && !opt.printInstructions) {
      var _option$urls, _option$urls2;
      var _getDocsData = (0, _staticDoc.getDocsData)(opt.docs),
        route = _getDocsData.route;
      option.urls.localUrlForTerminal += "\n  \\033[1mDocs Local:\\033[0m       ".concat((_option$urls = option.urls) === null || _option$urls === void 0 ? void 0 : _option$urls.localUrlForTerminal).concat(route, "\n");
      option.urls.lanUrlForTerminal += "\n  \\033[1mDocs On Your Network:\\033[0m   ".concat((_option$urls2 = option.urls) === null || _option$urls2 === void 0 ? void 0 : _option$urls2.lanUrlForTerminal).concat(route, "\n");
    }
    if (opt.docs && opt.printInstructions) {
      var docData = (0, _staticDoc.getDocsData)(opt.docs);
      opt.printInstructions((0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, opt), docData), {}, {
        createCompilerOption: option
      }));
    }
    return createCompiler(option);
  };
  require.cache[require.resolve(WebpackDevServerUtilsPath)].exports = devServerUtils;
}