import { Configuration } from 'webpack';
import MiniCssExtractPlugin from 'mini-css-extract-plugin';
export { MiniCssExtractPlugin };
/**
 * Fix Conflicting order
 * https://github.com/webpack-contrib/mini-css-extract-plugin/issues/250#issuecomment-532483344
 * https://github.com/webpack-contrib/mini-css-extract-plugin/issues/493
 * https://github.com/kktjs/kkt/issues/336
 *
 * ```
 * No module factory available for dependency type: CssDependency
 * chunk 0 [mini-css-extract-plugin]
 * Conflicting order. Following module has been added:
 * ```
 * @param conf
 * @param options
 */
export declare const miniCssExtractPlugin: (conf: Configuration, env: 'development' | 'production', options?: MiniCssExtractPlugin.PluginOptions) => Configuration;
