import WebpackDevServer from 'webpack-dev-server';
import { DevServerOptions, WebpackConfiguration } from '../utils/conf';
import { StartArgs } from '..';
export interface DocsDataResult {
    /**
     * document root
     * E.g: '/Users/xxx/kkt/node_modules/@uiw/doc/web'
     */
    docRoot?: string;
    /**
     * Document Access Routing
     * E.g: http://192.168.4.35:3003/_doc
     */
    route?: string;
    /**
     * E.g: '/Users/xxx/kkt/node_modules/@uiw/doc/web/package.json'
     */
    pkgPath?: string;
    root?: string;
    /**
     * E.g: '@uiw/doc/web'
     */
    dirPath?: string;
    /**
     * E.g: '@uiw/doc'
     */
    name?: string;
    raw?: string;
}
export declare function getDocsData(str?: string, route?: string): DocsDataResult;
/**
 * Specify a static service, which can be used for document preview
 * @param conf
 */
export declare const staticDocSetupMiddlewares: (middlewares: WebpackDevServer.Middleware[], devServer: WebpackDevServer, options: StartArgs & DevServerOptions & {
    config?: WebpackConfiguration;
}) => WebpackDevServer.Middleware[];
