export type Paths = {
    dotenv: string;
    appPath: string;
    appBuild: string;
    appPublic: string;
    appHtml: string;
    appIndexJs: string;
    appPackageJson: string;
    /** App Root Path */
    appSrc: string;
    appTsConfig: string;
    appJsConfig: string;
    yarnLockFile: string;
    testsSetup: string;
    proxySetup: string;
    appNodeModules: string;
    swSrc: string;
    publicUrlOrPath: string;
    ownPath: string;
    ownNodeModules: string;
    appTypeDeclarations: string;
    ownTypeDeclarations: string;
};
/** App Path */
declare const projectDir: string;
/**
 * Package [`react-scripts`](http://npmjs.com/react-scripts) directory location
 * - `<root path>/node_modules/react-scripts`
 */
declare const reactScripts: string;
/**
 * Package [`react-dev-utils`](http://npmjs.com/react-dev-utils) directory location
 * - `<root path>/node_modules/react-dev-utils`
 */
declare const reactDevUtils: string;
declare const paths: Paths;
/**
 * Overrides proxySetup path
 * `<root path>/node_modules/kkt/lib/utils/proxySetup.js`
 */
declare const proxySetup: string;
/**
 * 判断是否大于 2.1.2
 * CRA 2.1.2 switched to using a webpack config factory
 * https://github.com/facebook/create-react-app/pull/5722
 * https://github.com/facebook/create-react-app/releases/tag/v2.1.2
 */
declare const isWebpackFactory: boolean;
export { proxySetup, projectDir, reactScripts, reactDevUtils, isWebpackFactory, paths };
