"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reactScripts = exports.reactDevUtils = exports.proxySetup = exports.projectDir = exports.paths = exports.isWebpackFactory = void 0;
var _path = _interopRequireDefault(require("path"));
var _fs = _interopRequireDefault(require("fs"));
var _semver = _interopRequireDefault(require("semver"));
var _minimist = _interopRequireDefault(require("minimist"));
var args = process.argv.slice(2);
var argvs = (0, _minimist["default"])(args);

/** App Path */
var projectDir = exports.projectDir = _path["default"].resolve(_fs["default"].realpathSync(process.cwd()));

/**
 * Package [`react-scripts`](http://npmjs.com/react-scripts) directory location
 * - `<root path>/node_modules/react-scripts`
 */
var reactScripts = exports.reactScripts = _path["default"].join(require.resolve('react-scripts/package.json'), '..');
/**
 * Package [`react-dev-utils`](http://npmjs.com/react-dev-utils) directory location
 * - `<root path>/node_modules/react-dev-utils`
 */
var reactDevUtils = exports.reactDevUtils = _path["default"].join(require.resolve('react-dev-utils/package.json'), '..');
var paths = exports.paths = require("".concat(reactScripts, "/config/paths"));

/**
 * Overrides proxySetup path
 * `<root path>/node_modules/kkt/lib/utils/proxySetup.js`
 */
var proxySetup = exports.proxySetup = _path["default"].resolve(__dirname, './proxySetup.js');
/**
 * `<root path>/node_modules/react-scripts/package.json`
 */
var scriptPkg = require("".concat(reactScripts, "/package.json"));

/**
 * 判断是否大于 2.1.2
 * CRA 2.1.2 switched to using a webpack config factory
 * https://github.com/facebook/create-react-app/pull/5722
 * https://github.com/facebook/create-react-app/releases/tag/v2.1.2
 */
var isWebpackFactory = exports.isWebpackFactory = _semver["default"].gte(scriptPkg && scriptPkg.version, '2.1.2');